## com.bbn.openmap.layer.rpf
Interface RpfFrameProvider

All Known Implementing Classes:
  RpfFrameCacheHandler

public interface RpfFrameProvider

The RpfFrameProvider describes an interface to an object that can provide information about RPF coverage over a certain area, and also retrieve data from the RPF frame files.

Method Summary
`float` `getCalculatedCoverage(float ullat, float ullon, float lrlat, float lrlon, CADRG p, java.lang.String chartSeries)` Given an area and a two-letter chart series code, find the percentage of coverage on the map that that chart series can offer.
`java.util.Vector` `getCatalogCoverage(float ullat, float ullon, float lrlat, float lrlon, CADRG p, java.lang.String chartSeries)` Given a projection that describes a map or geographical area, return RpfCoverageBoxes that let you know what bounding boxes of data are available.
`java.util.Vector` `getCoverage(float ullat, float ullon, float lrlat, float lrlon, CADRG p)` Given a projection that describes a map or geographical area, return RpfCoverageBoxes that let you know how to locate and ask for RpfSubframes.
`RpfIndexedImageData` `getRawSubframeData(int tocNumber, int entryNumber, int x, int y)`
`java.lang.String` `getSubframeAttributes(int tocNumber, int entryNumber, int x, int y)` Given the indexes to a certain RpfTocEntry within a certain A.TOC, find the frame and return the attribute information.
`int[]` `getSubframeData(int tocNumber, int entryNumber, int x, int y)` Given the indexes to a certain RpfTocEntry within a certain A.TOC, find the frame/subframe data, decompress it, and return image pixels.
`boolean` `needViewAttributeUpdates()` Returns true if the view attributes should be set if they change at the RpfCacheHandler/RpfCacheManager.
`void` `setViewAttributes(RpfViewAttributes rva)` Set the RpfViewAttribute object parameters, which describes alot about what you'll be asking for later.

Method Detail

### needViewAttributeUpdates

    public boolean needViewAttributeUpdates()

  Returns true if the view attributes should be set if they change at the RpfCacheHandler/RpfCacheManager. If the source of the data is a server, this should return yes. If the source is local, the view attributes will be a shared object and updates are not nessary.

### setViewAttributes

    public void setViewAttributes(RpfViewAttributes rva)

  Set the RpfViewAttribute object parameters, which describes alot about what you'll be asking for later.

### getCoverage

    public java.util.Vector getCoverage(float ullat,
                                        float ullon,
                                        float lrlat,
                                        float lrlon,
                                        CADRG p)

  Given a projection that describes a map or geographical area, return RpfCoverageBoxes that let you know how to locate and ask for RpfSubframes.

### getCatalogCoverage

    public java.util.Vector getCatalogCoverage(float ullat,
                                               float ullon,
                                               float lrlat,
                                               float lrlon,
                                               CADRG p,
                                               java.lang.String chartSeries)

  Given a projection that describes a map or geographical area, return RpfCoverageBoxes that let you know what bounding boxes of data are available.

  Parameters:
    `ullat` - upper lat
    `ullon` - left lon
    `lrlat` - lower lat
    `lrlon` - right lon
    `chartSeries` - can be null to see all/any.

### getCalculatedCoverage

    public float getCalculatedCoverage(float ullat,
                                       float ullon,
                                       float lrlat,
                                       float lrlon,
                                       CADRG p,
                                       java.lang.String chartSeries)

  Given an area and a two-letter chart series code, find the percentage of coverage on the map that that chart series can offer. If you want specific coverage information, use the getCatalogCoverage call.

  See Also:
    `getCatalogCoverage(float, float, float, float, CADRG, String)`

### getSubframeData

    public int[] getSubframeData(int tocNumber,
                                 int entryNumber,
                                 int x,
                                 int y)

  Given the indexes to a certain RpfTocEntry within a certain A.TOC, find the frame/subframe data, decompress it, and return image pixels. The tocNumber and entryNumber are given within the RpfCoverageBox received from a getCoverage call.

  Parameters:
    `tocNumber` - the toc id for a RpfTocHandler for a particular frame provider.
    `entryNumber` - the RpfTocEntry id for a RpfTocHandler for a particular frame provider.
    `x` - the horizontal subframe index, from the left side of a boundary rectangle of the entry.
    `y` - the vertical subframe index, from the top side of a boundary rectangle of the entry.
  Returns:
    integer pixel data.
  See Also:
    `getCoverage(float, float, float, float, CADRG)`

### getRawSubframeData

    public RpfIndexedImageData getRawSubframeData(int tocNumber,
                                                  int entryNumber,
                                                  int x,
                                                  int y)

### getSubframeAttributes

    public java.lang.String getSubframeAttributes(int tocNumber,
                                                  int entryNumber,
                                                  int x,
                                                  int y)

  Given the indexes to a certain RpfTocEntry within a certain A.TOC, find the frame and return the attribute information. The tocNumber and entryNumber are given within the RpfCoverageBox received from a getCoverage call.

  Parameters:
    `tocNumber` - the toc id for a RpfTocHandler for a particular frame provider.
    `entryNumber` - the RpfTocEntry id for a RpfTocHandler for a particular frame provider.
    `x` - the horizontal subframe index, from the left side of a boundary rectangle of the entry.
    `y` - the vertical subframe index, from the top side of a boundary rectangle of the entry.
  Returns:
    string.
  See Also:
    `getCoverage(float, float, float, float, CADRG)`

Copyright (C) BBNT Solutions LLC; See http://openmap.bbn.com/ for details